////////////////////////////////////////////////
//
//
//
////////////////////////////////////////////////

#include "ai_interface.h"
#include "AIDriver.h"
#include <cmath>
#include "ai_utils.h"

namespace Lunar_AI
{
	static AI_Driver* ship_ai;

	const char * Get_AI_Name( )
	{
		return "Darcimus The Reliant";
	}

	void Init( )
	{
		ship_ai = new AI_Driver();
	} 

	void Cleanup( float final_score )
	{
		delete ship_ai;
	}

	void Tick( float delta_time, float lander_x, float lander_y, float lander_x_vel, float lander_y_vel, float lander_rotation,
				float goal_x, float goal_y,
				float sensor_data[ NUM_SENSORS ], float fuel_left,
				bool &thrusters_on, bool &rotate_left, bool &rotate_right)
	{
		// Create predefined variables
		float angle_to_goal = Utils::calc_angle(Vector2(lander_x, lander_y), Vector2(goal_x, goal_y));
		float distance_from_goal = Utils::distance_between(Vector2(lander_x, lander_y), Vector2(goal_x, goal_y));

		lander_rotation += PI / 2;
		if(lander_rotation > 2 * PI)
			lander_rotation -= 2 * PI;

		ship_ai->update_data(distance_from_goal, lander_rotation, sensor_data, goal_x, goal_y, lander_x, lander_y, lander_x_vel, lander_y_vel, fuel_left);
		ship_ai->update(delta_time);
		ship_ai->output_debug_data();

		thrusters_on = ship_ai->thrusters_on();
		rotate_left = ship_ai->turning_left();
		rotate_right = ship_ai->turning_right();
	}

}// namespace Lunar_AI
